<!--
  This issue template is for bug reports.
	There are other issue templates for feature requests, refactor proposals, and discussions,
	so please use them if this is not a bug report.

	Also, you don't need to prefix the issue title with "Bug:", because it's
	managed by issue labels.
-->

<!-- 💖 Thanks for taking the time to fill out this bug report!
💁 Having trouble with deployment? [Ask the support chat.](https://matrix.to/#/#firefish-community:nitro.chat)
🔒 Found a security vulnerability? [Please disclose it responsibly.](https://firefish.dev/firefish/firefish/-/blob/develop/SECURITY.md)
🤝 By submitting this issue, you agree to follow our [Contribution Guidelines.](https://firefish.dev/firefish/firefish/-/blob/develop/CONTRIBUTING.md) -->

## What type of issue is this?
<!-- If this happens on your device and has to do with the user interface, it's client-side. If this happens on either with the API or the backend, or you got a server-side error in the client, it's server-side. -->

<!-- Uncomment (remove surrounding arrow signs) the following line(s) to specify the category of this issue. -->
<!-- * label: Server -->
<!-- * label: Client -->
<!-- * label: Mobile -->
<!-- * label: Third-party-client -->
<!-- * label: Docs -->
<!-- * label: Locale -->
<!-- * label: Build from source -->
<!-- * label: Container -->
<!-- * label: Firefish API -->
<!-- * label: Mastodon API -->

<!-- Please do not edit the next line -->
* label: Bug

## What happened?
<!-- Please give us a brief description of what happened. -->


## What did you expect to happen?
<!-- Please give us a brief description of what you expected to happen. -->


## Steps to reproduce the issue
<!-- Please describe how to reproduce this issue (preferably, in a ordered list) -->


## Reproduces how often
<!-- Is it always reproducible, or is it conditional/probabilistic ? -->


## What did you try to solve the issue / Do you have any insights
<!-- Not to repeat the same thing, let us share what you have tried so far. -->


## Version
<!-- What version of firefish is your instance running? You can find this by the instance information page. -->


<details>

### Instance
<!-- What instance of firefish are you using? -->


### What browser are you using? (client-side issues only)


### What operating system are you using? (client-side issues only)


### How do you deploy Firefish on your server? (server-side issues only)


### What operating system are you using? (Server-side issues only)


### Relevant log output
<!-- Please copy and paste any relevant log output. -->


</details>

## Contribution Guidelines
By submitting this issue, you agree to follow our [Contribution Guidelines](https://firefish.dev/firefish/firefish/-/blob/develop/CONTRIBUTING.md)
- [ ] I agree to follow this project's Contribution Guidelines
- [ ] I have searched the issue tracker for similar issues, and this is not a duplicate.

## Are you willing to fix this bug? (optional)
- [ ] Yes, I will open a merge request that closes this ticket.

<!--
	Please tell us how to fix this bug.
	As noted in the contribution guidelines, there is a good chance that your
	merge request will not be merged if there is no agreement with the project maintainers.
	However, we are currently so understaffed that it is virtually impossible to
	respond to every single proposal. So, feel free to implement it if there is no response
	for more than a week or there is a thumbs-up emoji reaction from the project maintainer(s).

	Many thanks for your involvement!
-->

