## macOS installation methods

- install redis and postgresql

```bash
./install.sh
```

- build pgroonga

```bash
./build-pgroonga.sh
```

- start redis and postgresql

```bash
./start-postgres.sh

# and
./start-redis.sh
```

- setup detabase

* create db and user

```bash
psql -d postgres -U $USER
```

```sql
-- Create a new PostgreSQL user named 'firefish' with encrypted password.
-- This user will not have superuser, createdb, or createrole privileges.
CREATE USER firefish WITH ENCRYPTED PASSWORD 'password' SUPERUSER NOCREATEDB NOCREATEROLE;

-- Create a new database named 'firefish_db' with UTF8 encoding and owned by the 'firefish' user.
CREATE DATABASE firefish_db WITH ENCODING 'UTF8' OWNER firefish;

```

- enable pgroonga extension

```bash
# enter this command then type password
psql -U firefish -d firefish_db -W
```

```sql
-- This ensures the PGroonga extension is enabled for the database.
CREATE EXTENSION pgroonga;
```
