export const iso639Langs1 = {
	af: {
		nativeName: "Afrikaans",
	},
	ak: {
		nativeName: "Tɕɥi",
	},
	ar: {
		nativeName: "العربية",
		rtl: true,
	},
	ay: {
		nativeName: "Aymar aru",
	},
	az: {
		nativeName: "Azərbaycan dili",
	},
	be: {
		nativeName: "Беларуская",
	},
	bg: {
		nativeName: "Български",
	},
	bn: {
		nativeName: "বাংলা",
	},
	br: {
		nativeName: "Brezhoneg",
	},
	bs: {
		nativeName: "Bosanski",
	},
	ca: {
		nativeName: "Català",
	},
	cs: {
		nativeName: "Čeština",
	},
	cy: {
		nativeName: "Cymraeg",
	},
	da: {
		nativeName: "Dansk",
	},
	de: {
		nativeName: "Deutsch",
	},
	el: {
		nativeName: "Ελληνικά",
	},
	en: {
		nativeName: "English",
	},
	eo: {
		nativeName: "Esperanto",
	},
	es: {
		nativeName: "Español",
	},
	et: {
		nativeName: "eesti keel",
	},
	eu: {
		nativeName: "Euskara",
	},
	fa: {
		nativeName: "فارسی",
		rtl: true,
	},
	ff: {
		nativeName: "Fulah",
	},
	fi: {
		nativeName: "Suomi",
	},
	fo: {
		nativeName: "Føroyskt",
	},
	fr: {
		nativeName: "Français",
	},
	fy: {
		nativeName: "Frysk",
	},
	ga: {
		nativeName: "Gaeilge",
	},
	gd: {
		nativeName: "Gàidhlig",
	},
	gl: {
		nativeName: "Galego",
	},
	gn: {
		nativeName: "Avañe'ẽ",
	},
	gu: {
		nativeName: "ગુજરાતી",
	},
	gv: {
		nativeName: "Gaelg",
	},
	he: {
		nativeName: "עברית‏",
		rtl: true,
	},
	hi: {
		nativeName: "हिन्दी",
	},
	hr: {
		nativeName: "Hrvatski",
	},
	ht: {
		nativeName: "Kreyòl",
	},
	hu: {
		nativeName: "Magyar",
	},
	hy: {
		nativeName: "Հայերեն",
	},
	id: {
		nativeName: "Bahasa Indonesia",
	},
	is: {
		nativeName: "Íslenska",
	},
	it: {
		nativeName: "Italiano",
	},
	ja: {
		nativeName: "日本語",
	},
	jv: {
		nativeName: "Basa Jawa",
	},
	ka: {
		nativeName: "ქართული",
	},
	kk: {
		nativeName: "Қазақша",
	},
	kl: {
		nativeName: "kalaallisut",
	},
	km: {
		nativeName: "ភាសាខ្មែរ",
	},
	kn: {
		nativeName: "ಕನ್ನಡ",
	},
	ko: {
		nativeName: "한국어",
	},
	ku: {
		nativeName: "Kurdî",
	},
	kw: {
		nativeName: "Kernewek",
	},
	la: {
		nativeName: "Latin",
	},
	lb: {
		nativeName: "Lëtzebuergesch",
	},
	li: {
		nativeName: "Lèmbörgs",
	},
	lt: {
		nativeName: "Lietuvių",
	},
	lv: {
		nativeName: "Latviešu",
	},
	mg: {
		nativeName: "Malagasy",
	},
	mk: {
		nativeName: "Македонски",
	},
	ml: {
		nativeName: "മലയാളം",
	},
	mn: {
		nativeName: "Монгол",
	},
	mr: {
		nativeName: "मराठी",
	},
	ms: {
		nativeName: "Bahasa Melayu",
	},
	mt: {
		nativeName: "Malti",
	},
	my: {
		nativeName: "ဗမာစကာ",
	},
	no: {
		nativeName: "Norsk",
	},
	nb: {
		nativeName: "Norsk (bokmål)",
	},
	ne: {
		nativeName: "नेपाली",
	},
	nl: {
		nativeName: "Nederlands",
	},
	nn: {
		nativeName: "Norsk (nynorsk)",
	},
	oc: {
		nativeName: "Occitan",
	},
	or: {
		nativeName: "ଓଡ଼ିଆ",
	},
	pa: {
		nativeName: "ਪੰਜਾਬੀ",
	},
	pl: {
		nativeName: "Polski",
	},
	ps: {
		nativeName: "پښتو",
		rtl: true,
	},
	pt: {
		nativeName: "Português",
	},
	qu: {
		nativeName: "Qhichwa",
	},
	rm: {
		nativeName: "Rumantsch",
	},
	ro: {
		nativeName: "Română",
	},
	ru: {
		nativeName: "Русский",
	},
	sa: {
		nativeName: "संस्कृतम्",
	},
	se: {
		nativeName: "Davvisámegiella",
	},
	sh: {
		nativeName: "српскохрватски",
	},
	si: {
		nativeName: "සිංහල",
	},
	sk: {
		nativeName: "Slovenčina",
	},
	sl: {
		nativeName: "Slovenščina",
	},
	so: {
		nativeName: "Soomaaliga",
	},
	sq: {
		nativeName: "Shqip",
	},
	sr: {
		nativeName: "Српски",
	},
	su: {
		nativeName: "Basa Sunda",
	},
	sv: {
		nativeName: "Svenska",
	},
	sw: {
		nativeName: "Kiswahili",
	},
	ta: {
		nativeName: "தமிழ்",
	},
	te: {
		nativeName: "తెలుగు",
	},
	tg: {
		nativeName: "забо́ни тоҷикӣ́",
	},
	th: {
		nativeName: "ภาษาไทย",
	},
	tr: {
		nativeName: "Türkçe",
	},
	tt: {
		nativeName: "татарча",
	},
	uk: {
		nativeName: "Українська",
	},
	ur: {
		nativeName: "اردو",
		rtl: true,
	},
	uz: {
		nativeName: "O'zbek",
	},
	vi: {
		nativeName: "Tiếng Việt",
	},
	xh: {
		nativeName: "isiXhosa",
	},
	yi: {
		nativeName: "ייִדיש",
		rtl: true,
	},
	zh: {
		nativeName: "中文",
	},
	zu: {
		nativeName: "isiZulu",
	},
};

export const iso639Langs3 = {
	ach: {
		nativeName: "Lwo",
	},
	ady: {
		nativeName: "Адыгэбзэ",
	},
	cak: {
		nativeName: "Maya Kaqchikel",
	},
	chr: {
		nativeName: "ᏣᎳᎩ (tsalagi)",
	},
	dsb: {
		nativeName: "Dolnoserbšćina",
	},
	fil: {
		nativeName: "Filipino",
	},
	hsb: {
		nativeName: "Hornjoserbšćina",
	},
	kab: {
		nativeName: "Taqbaylit",
	},
	mai: {
		nativeName: "मैथिली, মৈথিলী",
	},
	tlh: {
		nativeName: "tlhIngan-Hol",
	},
	tok: {
		nativeName: "Toki Pona",
	},
	yue: {
		nativeName: "粵語",
	},
	nan: {
		nativeName: "閩南語",
	},
};

export const langmapNoRegion = Object.assign({}, iso639Langs1, iso639Langs3);

export const iso639Regional = {
	"zh-hans": {
		nativeName: "中文（简体）",
	},
	"zh-hant": {
		nativeName: "中文（繁體）",
	},
};

// Maverify a BCP 57 language tag (by ericP, CC BY-SA 4.0 https://stackoverflow.com/a/60899733)
export const bcp47Pattern =
	/^((?<grandfathered>(en-GB-oed|i-ami|i-bnn|i-default|i-enochian|i-hak|i-klingon|i-lux|i-mingo|i-navajo|i-pwn|i-tao|i-tay|i-tsu|sgn-BE-FR|sgn-BE-NL|sgn-CH-DE)|(art-lojban|cel-gaulish|no-bok|no-nyn|zh-guoyu|zh-hakka|zh-min|zh-min-nan|zh-xiang))|((?<language>([A-Za-z]{2,3}(-(?<extlang>[A-Za-z]{3}(-[A-Za-z]{3}){0,2}))?)|[A-Za-z]{4}|[A-Za-z]{5,8})(-(?<script>[A-Za-z]{4}))?(-(?<region>[A-Za-z]{2}|[0-9]{3}))?(-(?<variant>[A-Za-z0-9]{5,8}|[0-9][A-Za-z0-9]{3}))*(-(?<extension>[0-9A-WY-Za-wy-z](-[A-Za-z0-9]{2,8})+))*(-(?<privateUse>x(-[A-Za-z0-9]{1,8})+))?)|(?<privateUse1>x(-[A-Za-z0-9]{1,8})+))$/i;

export const langmap = Object.assign({}, langmapNoRegion, iso639Regional);
export type PostLanguage = keyof typeof langmap;
